local T, C, L = unpack(Tukui)

---------------------------------------------------
-- invis background panel
---------------------------------------------------
local uibbg = CreateFrame("Frame", "UIButtonsBackground", UIParent)
uibbg:Size(150, 88)
uibbg:Point("CENTER", UIParent, "CENTER", -267, -122)
uibbg:SetTemplate("Transparent")
uibbg:SetFrameStrata("Background")
uibbg:Hide()
uibbg:SetMovable(true)
uibbg:SetScript("OnMouseDown", function() uibbg:ClearAllPoints() uibbg:StartMoving() end)
uibbg:SetScript("OnMouseUp", function() uibbg:StopMovingOrSizing() end)

local uibbgt = CreateFrame("Frame", "UIButtonsBackgroundTitle", UIButtonsBackground)
uibbgt:Size(150, 15)
uibbgt:Point("BOTTOM", UIButtonsBackground, "TOP", 0, 1)
uibbgt:SetTemplate("Transparent")
uibbgt:SetFrameStrata("Background")
uibbgt:FontString("Text", C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
uibbgt.Text:Point("CENTER", UIButtonsBackgroundTitle)
uibbgt.Text:SetText("CONTROLPANEL")

-- Close button for frame
local uibbgc = CreateFrame("Button", "UIButtonsBackgroundClose", UIButtonsBackgroundTitle)
uibbgc:Size(8,8)
uibbgc:Point("TOPRIGHT", UIButtonsBackgroundTitle, "TOPRIGHT", -2, -3)
uibbgc:SetBackdropColor(0,0,0,0)
uibbgc:SetBackdropBorderColor(0,0,0,0)
uibbgc:SetFrameLevel(UIButtonsBackgroundTitle:GetFrameLevel() + 1)
uibbgc:FontString("Text", C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
uibbgc.Text:Point("CENTER", UIButtonsBackgroundClose)
uibbgc.Text:SetText("x")
uibbgc:SetScript("OnClick", function()
	UIButtonsBackground:Hide()
end)

-- Create UICrontolButton
local clWidth = C.chat.chatbackgroundwidth
local uicb = CreateFrame("Frame", "UIControlButton", ChatBackgroundLeft)
uicb:ClearAllPoints()
uicb:Size(15, 65)
uicb:SetTemplate("Transparent")
uicb:Point("CENTER", ChatBackgroundLeft, "CENTER", ((clWidth/2)+9), 0)
uicb:FontString("Text", C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
uicb.Text:Point("CENTER", UIControlButton, "CENTER", 3, 0) 
uicb.Text:SetShadowOffset(1, -1)
uicb.Text:SetText("C\nO\nN\nT\nR\nO\nL")
	uicb:HookScript("OnEnter", function(self)
		self:SetBackdropBorderColor(1,1,1)
	end)
	uicb:HookScript("OnLeave", function(self)
		self:SetBackdropBorderColor(0,0,0)
	end)

UIControlButton:SetScript("OnMouseDown", function(self)
if InCombatLockdown() then print(ERR_NOT_IN_COMBAT) return end
	if UIButtonsBackground:IsShown() then
		UIButtonsBackground:Hide()
else	
		UIButtonsBackground:Show()
	end
end)

-- topline vertical
local tplv = CreateFrame("Frame", "UIBTopLineVertical", UIControlButton)
tplv:Size(2,15)
tplv:Point("CENTER", UIControlButton, "CENTER", 0, 40)
tplv:SetTemplate("Default")

-- topline horizontal
local tplh = CreateFrame("Frame", "UIBTopLineHorizontal", UIControlButton)
tplh:Size(11,2)
tplh:Point("CENTER", UIControlButton, "CENTER", -5, 48)
tplh:SetTemplate("Default")

-- bottomline vertical
local bplv = CreateFrame("Frame", "UIBBottomLineVertical", UIControlButton)
bplv:Size(2,15)
bplv:Point("CENTER", UIControlButton, "CENTER", 0, -40)
bplv:SetTemplate("Default")

-- bottomline horizontal
local bplh = CreateFrame("Frame", "UIBBottomLineHorizontal", UIControlButton)
bplh:Size(11,2)
bplh:Point("CENTER", UIControlButton, "CENTER", -5, -48)
bplh:SetTemplate("Default")

---------------------------------------------------------
-- Create UIButtons
---------------------------------------------------------

local function CreateUIButton(name, parent, text)
	local b = CreateFrame("Button", name, parent, "SecureActionButtonTemplate")
	b:Size (70, 13)
	b:StripTextures(true)
	b:SetTemplate("Default")
	b:SetBackdropColor(.06,.06,.06, .7)
	b:EnableMouse(true)
	b:RegisterForClicks("AnyUp")
	
	b:HookScript("OnEnter", function(self)
		self:SetBackdropBorderColor(1,1,1)
		self:SetBackdropColor(.06,.06,.06, .7)
	end)
	b:HookScript("OnLeave", function(self)
		self:SetBackdropBorderColor(0,0,0)
		self:SetBackdropColor(.06,.06,.06, .7)
	end)
	
	b:FontString(nil, C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
	b.text:SetText(text)
	b.text:SetPoint("CENTER", b)
end

CreateUIButton("KacaosUI_Config_Button", UIButtonsBackground, "Config")
KacaosUI_Config_Button:SetAttribute("type1", "macro")
KacaosUI_Config_Button:SetAttribute("macrotext1", "/tukui")
KacaosUI_Config_Button.text:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_Config_Button.text:SetShadowOffset(0,0)
KacaosUI_Config_Button:Point("LEFT", UIButtonsBackground, "LEFT", 4, 0)
KacaosUI_Config_Button:SetFrameLevel(3)
KacaosUI_Config_Button:EnableMouse(true)
KacaosUI_Config_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, 3)
		  GameTooltip:AddLine("ConfigUi", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Click to open the ingame config for tukui", 1, 1, 1, 1, 1, 1)
		  GameTooltip:Show()
        end)
KacaosUI_Config_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)

CreateUIButton("KacaosUI_MoveUI_Button", UIButtonsBackground, "MoveUi")
KacaosUI_MoveUI_Button:SetAttribute("type1", "macro")
KacaosUI_MoveUI_Button:SetAttribute("macrotext1", "/moveui")
KacaosUI_MoveUI_Button.text:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_MoveUI_Button.text:SetShadowOffset(0,0)
KacaosUI_MoveUI_Button:Point("LEFT", UIButtonsBackground, "LEFT", 4, -17)
KacaosUI_MoveUI_Button:EnableMouse(true)
KacaosUI_MoveUI_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, -4)
          GameTooltip:AddLine("MoveUi", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Click to toggle move some elements", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
KacaosUI_MoveUI_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)

CreateUIButton("KacaosUI_stam_Button", UIButtonsBackground, "AddOns")
KacaosUI_stam_Button:SetAttribute("type1", "macro")
KacaosUI_stam_Button:SetAttribute("macrotext1", "/am")
KacaosUI_stam_Button.text:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_stam_Button.text:SetShadowOffset(0,0)
KacaosUI_stam_Button:Point("LEFT", UIButtonsBackground, "LEFT", 4, -34)
KacaosUI_stam_Button:EnableMouse(true)
KacaosUI_stam_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, -9)
          GameTooltip:AddLine("AddonManager", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Click to open AddonManager", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
KacaosUI_stam_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)

CreateUIButton("KacaosUI_rl_Button", UIButtonsBackground, "Reload")
KacaosUI_rl_Button:Size(70, 13)
KacaosUI_rl_Button:SetAttribute("type1", "macro")
KacaosUI_rl_Button:SetAttribute("macrotext1", "/rl")
KacaosUI_rl_Button.text:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_rl_Button.text:SetShadowOffset(0,0)
KacaosUI_rl_Button:Point("LEFT", UIButtonsBackground, "LEFT", 4, 16)
KacaosUI_rl_Button:EnableMouse(true)
KacaosUI_rl_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, -18)
          GameTooltip:AddLine("ReloadUI", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Click to ReloadUI", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
KacaosUI_rl_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)

CreateUIButton("KacaosUI_tb_Button", UIButtonsBackground, "Testui")
KacaosUI_tb_Button:Size(70, 13)
KacaosUI_tb_Button:SetAttribute("type1", "macro")
KacaosUI_tb_Button:SetAttribute("macrotext1", "/testui boss")
KacaosUI_tb_Button.text:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_tb_Button.text:SetShadowOffset(0,0)
KacaosUI_tb_Button:Point("RIGHT", UIButtonsBackground, "RIGHT", -4, 16)
KacaosUI_tb_Button:EnableMouse(true)
KacaosUI_tb_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, -25)
          GameTooltip:AddLine("TestUI Boss", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Click to toggle Bossframes (only testmodus)", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
KacaosUI_tb_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)

CreateUIButton("KacaosUI_help_Button", UIButtonsBackground, "Help")
KacaosUI_help_Button:Size(70, 13)
KacaosUI_help_Button:SetAttribute("type1", "macro")
KacaosUI_help_Button:SetAttribute("macrotext1", "/kuihelp")
KacaosUI_help_Button.text:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_help_Button.text:SetShadowOffset(0,0)
KacaosUI_help_Button:Point("LEFT", UIButtonsBackground, "LEFT", 4, 33)
KacaosUI_help_Button:EnableMouse(true)
KacaosUI_help_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, -25)
          GameTooltip:AddLine("Help", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Toggle Helpframe window", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
KacaosUI_help_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)

CreateUIButton("KacaosUI_rdebuff_Button", UIButtonsBackground, "Debuffs")
KacaosUI_rdebuff_Button:Size(70, 13)
KacaosUI_rdebuff_Button:SetAttribute("type1", "macro")
KacaosUI_rdebuff_Button:SetAttribute("macrotext1", "/debuffs")
KacaosUI_rdebuff_Button.text:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_rdebuff_Button.text:SetShadowOffset(0,0)
KacaosUI_rdebuff_Button:Point("RIGHT", UIButtonsBackground, "RIGHT", -4, 0)
KacaosUI_rdebuff_Button:EnableMouse(true)
KacaosUI_rdebuff_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, -25)
          GameTooltip:AddLine("raidDebuffs", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Toggle Raiddebuff window (To edit debuffs to your grid)", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
KacaosUI_rdebuff_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)

CreateUIButton("KacaosUI_kb_Button", UIButtonsBackground, "Keybind")
KacaosUI_kb_Button:Size(70, 13)
KacaosUI_kb_Button:SetAttribute("type1", "macro")
KacaosUI_kb_Button:SetAttribute("macrotext1", "/kb")
KacaosUI_kb_Button.text:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_kb_Button.text:SetShadowOffset(0,0)
KacaosUI_kb_Button:Point("RIGHT", UIButtonsBackground, "RIGHT", -4, -17)
KacaosUI_kb_Button:EnableMouse(true)
KacaosUI_kb_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, -25)
          GameTooltip:AddLine("Keybinds", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Enable Keybind modus", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
KacaosUI_kb_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)

--show / hide button
local KacaosUI_Minimap_Button = CreateFrame("Frame", "MinimapToggle", UIButtonsBackground)
KacaosUI_Minimap_Button:Height(13)
KacaosUI_Minimap_Button:Width(70)
KacaosUI_Minimap_Button:Point("RIGHT", UIButtonsBackground, "RIGHT", -4, -34)
KacaosUI_Minimap_Button:SetTemplate("Default")
KacaosUI_Minimap_Button:SetBackdropColor(.06,.06,.06, .7)
KacaosUI_Minimap_Button.t = KacaosUI_Minimap_Button:CreateFontString(KacaosUI_Minimap_Button, "OVERLAY")
KacaosUI_Minimap_Button.t:SetPoint("CENTER", KacaosUI_Minimap_Button, "CENTER", 0, 0)
KacaosUI_Minimap_Button.t:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_Minimap_Button.t:SetShadowOffset(0,0)
KacaosUI_Minimap_Button.t:SetText("Minimap")
KacaosUI_Minimap_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, 3)
		  GameTooltip:AddLine("Minimap", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Show/Hide Minimap", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
KacaosUI_Minimap_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)
	KacaosUI_Minimap_Button:HookScript("OnEnter", function(self)
		self:SetBackdropBorderColor(1,1,1)
	end)
	KacaosUI_Minimap_Button:HookScript("OnLeave", function(self)
		self:SetBackdropBorderColor(0,0,0)
	end)
	
CreateUIButton("KacaosUI_rcd_Button", UIButtonsBackground, "RaidCD")
KacaosUI_rcd_Button:Size(70, 13)
KacaosUI_rcd_Button:SetAttribute("type1", "macro")
KacaosUI_rcd_Button:SetAttribute("macrotext1", "/raidcd")
KacaosUI_rcd_Button.text:SetFont(C.media.pixelfont, 8, "MONOCHROMEOUTLINE")
KacaosUI_rcd_Button.text:SetShadowOffset(0,0)
KacaosUI_rcd_Button:Point("RIGHT", UIButtonsBackground, "RIGHT", -4, 33)
KacaosUI_rcd_Button:EnableMouse(true)
KacaosUI_rcd_Button:HookScript("OnEnter", function(self)
          GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -75, -25)
          GameTooltip:AddLine("RaidCD", .6, .6, .6, .6, .6, 1)
          GameTooltip:AddLine("Toggle RaidCD bars", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
KacaosUI_rcd_Button:HookScript("OnLeave", function(self) GameTooltip:Hide() end)


KacaosUI_Minimap_Button:SetScript("OnMouseDown", function(self)
	if TukuiMinimap:IsShown() then
		TukuiMinimap:Hide()
			if C.misc.raidbuffreminder == true then
				TukuiTooltipAnchor:ClearAllPoints()
				TukuiTooltipAnchor:SetClampedToScreen(false)
				TukuiTooltipAnchor:Point("BOTTOMRIGHT", Minimap, "BOTTOMLEFT", 97, -30)
				RaidBuffReminder:Point("TOPRIGHT", TukuiMinimap, "TOPLEFT", 120, 0)
			else
				TukuiTooltipAnchor:ClearAllPoints()
				TukuiTooltipAnchor:SetClampedToScreen(false)
				TukuiTooltipAnchor:Point("BOTTOMRIGHT", Minimap, "BOTTOMLEFT", 118, -30)
			end
	else
		TukuiMinimap:Show()
			if C.misc.raidbuffreminder == true then
				TukuiTooltipAnchor:ClearAllPoints()
				TukuiTooltipAnchor:SetClampedToScreen(false)
				TukuiTooltipAnchor:Point("BOTTOMRIGHT", Minimap, "BOTTOMLEFT", -25, -30)
				RaidBuffReminder:Point("TOPRIGHT", TukuiMinimap, "TOPLEFT", -1, 0)
			else
				TukuiTooltipAnchor:ClearAllPoints()
				TukuiTooltipAnchor:SetClampedToScreen(false)
				TukuiTooltipAnchor:Point("BOTTOMRIGHT", Minimap, "BOTTOMLEFT", -5, -30)
			end
	end 
end)